I'm really sorry about issues with problems E and F. Can't say anything more because I don't want to justify my mistakes.

Idea: vovuh

**Tutorial**

Tutorial is loading...

**Solution**

```
#include <bits/stdc++.h>
using namespace std;
int main() {
#ifdef _DEBUG
freopen("input.txt", "r", stdin);
// freopen("output.txt", "w", stdout);
#endif
int t;
cin >> t;
while (t--) {
string x;
cin >> x;
int dig = x[0] - '0' - 1;
int len = x.size();
cout << dig * 10 + len * (len + 1) / 2 << endl;
}
return 0;
}
```

Idea: vovuh

**Tutorial**

Tutorial is loading...

**Solution**

```
#include <bits/stdc++.h>
using namespace std;
int main() {
#ifdef _DEBUG
freopen("input.txt", "r", stdin);
// freopen("output.txt", "w", stdout);
#endif
int t;
cin >> t;
while (t--) {
int n;
cin >> n;
vector<int> a(n);
for (auto &it : a) cin >> it;
while (a.back() == 0) a.pop_back();
reverse(a.begin(), a.end());
while (a.back() == 0) a.pop_back();
cout << count(a.begin(), a.end(), 0) << endl;
}
return 0;
}
```

Idea: vovuh

**Tutorial**

Tutorial is loading...

**Solution**

```
#include <bits/stdc++.h>
using namespace std;
int main() {
#ifdef _DEBUG
freopen("input.txt", "r", stdin);
// freopen("output.txt", "w", stdout);
#endif
int t;
cin >> t;
while (t--) {
int n;
cin >> n;
vector<int> a(n);
int mx = 0;
for (auto &it : a) {
cin >> it;
mx = max(mx, it);
}
int idx = -1;
for (int i = 0; i < n; ++i) {
if (a[i] != mx) continue;
if (i > 0 && a[i - 1] != mx) idx = i + 1;
if (i < n - 1 && a[i + 1] != mx) idx = i + 1;
}
cout << idx << endl;
}
return 0;
}
```

Idea: MikeMirzayanov

**Tutorial**

Tutorial is loading...

**Solution**

```
#include <bits/stdc++.h>
using namespace std;
int main() {
#ifdef _DEBUG
freopen("input.txt", "r", stdin);
// freopen("output.txt", "w", stdout);
#endif
int t;
cin >> t;
while (t--) {
int n;
cin >> n;
vector<int> a(n);
for (auto &it : a) cin >> it;
vector<pair<int, int>> res;
int idx = -1;
for (int i = 1; i < n; ++i) {
if (a[i] != a[0]) {
idx = i;
res.push_back({1, i + 1});
}
}
if (idx == -1) {
cout << "NO" << endl;
continue;
}
for (int i = 1; i < n; ++i) {
if (a[i] == a[0]) {
res.push_back({idx + 1, i + 1});
}
}
cout << "YES" << endl;
for (auto [x, y] : res) cout << x << " " << y << endl;
}
return 0;
}
```

Idea: MikeMirzayanov

**Tutorial**

Tutorial is loading...

**Solution**

```
#include <bits/stdc++.h>
using namespace std;
const int N = 21;
long long f[N];
int main() {
#ifdef _DEBUG
freopen("input.txt", "r", stdin);
// freopen("output.txt", "w", stdout);
#endif
int n;
cin >> n;
f[0] = 1;
for (int i = 1; i < N; ++i) {
f[i] = f[i - 1] * i;
}
long long ans = f[n] / f[n / 2] / f[n / 2];
ans = ans * f[n / 2 - 1];
ans = ans * f[n / 2 - 1];
ans /= 2;
cout << ans << endl;
return 0;
}
```

Idea: MikeMirzayanov

**Tutorial**

Tutorial is loading...

**Solution**

```
#include <bits/stdc++.h>
using namespace std;
#define forn(i, n) for (int i = 0; i < int(n); ++i)
const int N = 75;
const int INF = 1e9;
int a[N][N];
int dp[N][N][N][N];
int main() {
#ifdef _DEBUG
freopen("input.txt", "r", stdin);
// freopen("output.txt", "w", stdout);
#endif
int n, m, k;
cin >> n >> m >> k;
forn(i, n) forn(j, m) {
cin >> a[i][j];
}
forn(i, N) forn(j, N) forn(cnt, N) forn(rem, N) dp[i][j][cnt][rem] = -INF;
dp[0][0][0][0] = 0;
forn(i, n) forn(j, m) forn(cnt, m / 2 + 1) forn(rem, k) {
if (dp[i][j][cnt][rem] == -INF) continue;
int ni = (j == m - 1 ? i + 1 : i);
int nj = (j == m - 1 ? 0 : j + 1);
if (i != ni) {
dp[ni][nj][0][rem] = max(dp[ni][nj][0][rem], dp[i][j][cnt][rem]);
} else {
dp[ni][nj][cnt][rem] = max(dp[ni][nj][cnt][rem], dp[i][j][cnt][rem]);
}
if (cnt + 1 <= m / 2) {
int nrem = (rem + a[i][j]) % k;
if (i != ni) {
dp[ni][nj][0][nrem] = max(dp[ni][nj][0][nrem], dp[i][j][cnt][rem] + a[i][j]);
} else {
dp[ni][nj][cnt + 1][nrem] = max(dp[ni][nj][cnt + 1][nrem], dp[i][j][cnt][rem] + a[i][j]);
}
}
}
cout << max(0, dp[n][0][0][0]) << endl;
return 0;
}
```

1433G - Reducing Delivery Cost

Idea: MikeMirzayanov

**Tutorial**

Tutorial is loading...

**Solution**

```
#include <bits/stdc++.h>
using namespace std;
const int INF = 1e9;
int n;
vector<vector<int>> d;
vector<vector<pair<int, int>>> g;
void dijkstra(int s, vector<int> &d) {
d = vector<int>(n, INF);
d[s] = 0;
set<pair<int, int>> st;
st.insert({d[s], s});
while (!st.empty()) {
int v = st.begin()->second;
st.erase(st.begin());
for (auto [to, w] : g[v]) {
if (d[to] > d[v] + w) {
auto it = st.find({d[to], to});
if (it != st.end()) st.erase(it);
d[to] = d[v] + w;
st.insert({d[to], to});
}
}
}
}
int main() {
#ifdef _DEBUG
freopen("input.txt", "r", stdin);
// freopen("output.txt", "w", stdout);
#endif
int m, k;
cin >> n >> m >> k;
g = vector<vector<pair<int, int>>>(n);
for (int i = 0; i < m; ++i) {
int x, y, w;
cin >> x >> y >> w;
--x, --y;
g[x].push_back({y, w});
g[y].push_back({x, w});
}
vector<pair<int, int>> r(k);
for (auto &[a, b] : r) {
cin >> a >> b;
--a, --b;
}
d = vector<vector<int>>(n);
for (int v = 0; v < n; ++v) {
dijkstra(v, d[v]);
}
int ans = INF;
for (int v = 0; v < n; ++v) {
for (auto [to, w] : g[v]) {
int cur = 0;
for (auto [a, b] : r) {
cur += min({d[a][b], d[a][v] + d[to][b], d[a][to] + d[v][b]});
}
ans = min(ans, cur);
}
}
cout << ans << endl;
return 0;
}
```

Thank you Vovuh for all of your time and effort you put into these Div 3s, please don't stop :( Also, E is a good problem if OEIS didn't exist, I found it pretty constructive. F too hard for a brik like me

How to solve E using OEIS? Never used OEIS before.

OEIS is an encyclopedia for integer sequences. You can search by entering a sequence and you will find all others with formulas also. As, for problem E there can be only 10 inputs, and 4 of them are given, so simply searching with the sequence can be find from OEIS

It could be found even by this number 12164510040883200

first, write a brute-force to generate the first few elements of the sequence or you can generate by hand in pen and paper, with those elements search in the OEIS. you will get all the sequences that start with these elements.

Would have used some MOD, then it's not straight forward!

without OEIS we can solve , by using simple math (n-1)!/(n/2) it's simple apply mathematics formula like combination of sitting in circular table (n-1)!/2

Nice round vovuh really enjoyed the round !! Thanks for the round , hoping to have more such rounds with the interesting problems again.

In problem E how can we find sequence on OEIS ?? since we do not know the ans for i/p :6??

Underscore works as a wildcard:

1, 3, _, 1260, _, _, _, _, _, 12164510040883200

Can you tell what is OEIS and how we can get anser from that??

oeis.org Web result with site links The On-Line Encyclopedia of Integer ... It contains information about integer sequences. For example the search https://oeis.org/search?q=1%2C+3%2C+_%2C+1260%2C+_%2C+_%2C+_%2C+_%2C+_%2C+12164510040883200&language=english&go=Search shows that such a sequence is known and displays formulas to get the nth term and more.

but how do we find that sequence what you searched in google specicifically??

Go to the website and enter the sequence or google the sequence and write oeis with it

This was more useful than any above answers :)

"Let dp[x][y][cnt][rem] be the maximum possible sum we can obtain if we are at the element ax,y right now, we took cnt elements in the row x and our current remainder is cnt."

Shouldn't the current remainder be rem instead of cnt? I didn't AC this problem, and I want to know the solution. This round was fun, thank you. :)

Thanks, that was a typo, I fixed it.

Can someone suggest some problems similar to F one , i.e, combining the concept of dp and remainder ?

https://mirror.codeforces.com/contest/1324/problem/E

I think this is way simpler and a little different.

Very nice problemset, these round really help us (beginners) to improve and let us see that you really take care of this platform :)

these were a bit too easy for mech keyboard merchants to type and get the precious rating.

Amazing Editorial!

E is a good problem. I really like it.

typo in D:

"Let's find any district $$$i$$$ that $$$a_i \ne a_i$$$"

It should be $$$a_i \ne a_1$$$

Thanks, fixed.

Test cases for problem F were weak, like I just calculate the maximum sum I can get in matrix choosing m/2 element in each row lets call it sum then I print (sum/k)*k , its like greatest multiple of k just smaller then sum, and boom I got AC :). PS:: Later it got hacked (:.

In the editorial of F it's written

our current remainder is cnt.whereas it should beour current remainder is rem.I didn't understand one thing. In the first problem, why did he write 'dig=x[0]-'0'',basically,subtract the zero.

x[0] is a character....to get the correct integer.. char of 0 is removed. for eg: let x[0] = '3' so x[0] — '0' = 51 — 48 = 3

in C answer will be index of maximum element why is it showing wrong answer

TC15 5 5 5 2

TC22 5 5 5 5

The answer will be the index of maximum element

adjacent to a non maximal element. If suppose, one prints only index of maximum then it could be right in between 2 maximal elements, such as index 1 in 4 4 4 3. Index 1 is maximum in the array but it is next to another maximum and cannot eat the number next to it.There are multiple answers. 4 4 4 3 = 4 4 5 so index 3 is the answer

The approach to sentence E is simpler 96159630: there are n people, calculate the number of ways to make 2 circles.

The first person has 1 choice (because he is the first person in the first circle), the second person has n-1 choice, the third person has n-2 choices, ..., the n / 2 person has n / 2 + 1 choice, n / 2 + 1 person has 1 choice (since this is the first of the second circle), the n / 2 + 2 person has n / 2-1 choice .. .

For example:

With n = 6, the number of ways to choose will be calculated as 1x5x4x1x2x1.

With n = 8, the number of ways to choose will be calculated as 1x7x6x5x1x3x2x1.

=> The general formula is (n-1)! / (n/2).

Sorry for my English not good.

Can someone please explain in problem E how we choose permutations as n!/(n/2)? (Sorry for the silly question)

You can see more here

In Problem E why we have to divide our answer by 2 ?

You can see more here

I got that logic. But I was trying to find out the tutorial

The Dancing pairs

`[1, 2 ,3 ,4] [5, 6, 7 ,8]`

is same as`[5, 6, 7, 8] [1, 2, 3, 4]`

so, when we applied the formula, we are counting every possible pair twice. So, we need to divide the answer by 2.There is a simpler formula in Problem E. Since we need exactly different round dances, we can notice that all of them can be represented as permutations with a fixed first element (for example, with a fixed number 1 at the beginning). Then the number of such sequences will be (n-1)!, now we just need to divide this number by (n / 2) (I don't know exactly how to prove why this works, but it works XD).

Oh, I didn't notice that this solution was already shown above.

Don't know why are you encouraging to find sequence on OEIS for E?It is bit surprising to see that

Would've been a bit difficult if one didn't know the math. I think that should've been done though. It turned out to be too easy right now.

You are very pretty <3

When will the changed rating be reflected in the account?

About an hour after finishing system testing..

means in 20-25 min from now right??;-) , I am excited bcz it's my best rank yet.

Can anyone help me to understand how to approach for problem F?

In this dp problem, we are simply tracking the results on variation of

every parameter(since constraints are low, seeing every possibility like Dr. Strange ;D).Firstly, we are traversing over every element in the matrix. Secondly, we are also traversing over all possible number of elements picked in a row. And also varying remainder of total sum. If a configuration with such properties (number of elements picked in that row and the total sum remainder) exists, $$$dp[i][j][cnt][rem]$$$ will have the max sum. Otherwise value will remain $$$-inf$$$.

If you have solved dp problems before, you'll have an idea now. Otherwise, I urge you to practice basic dp problems, after which you'll solve this one.

In F , why the answer is stored at dp(n,0,0,0)?? Thank U

dp[n][0][0][0] represents max sum, when we are at (n,0) [

out of the matrix], i.e we have traversed the matrix and came out of it, with 0 elements picked in this row(obviously, because this row is not a part of the matrix), with the sum havin 0 remainder.Это довольно стандартная задача на динамическое программирование. Пусть dp[x][y][cnt][rem] равно максимальной сумме, которую мы можем получить, если сейчас мы находимся на элементе ax,y, взяли

cntэлементов в строке x и наш текущий остаток равенcnt(скорее всего хотели сказатьrem).Solution of problem G is giving compilation error given by you. Can you please recheck

I just spent whole

2hours during the contest thinking on $$$F$$$ that $$$O(N^4)$$$ space solution won't work in $$$1$$$secondand wrote a $$$O(N^3)$$$ space + $$$O(N^4)$$$ time solution & kept debugging it till end and got AC when 7 minutes left. Yesterday i realised how bad i am at handling base cases in iterative dp.Can anyone share how do they identify whether their solution will work or not

when no. of operations & size of the array used is of the order more than ~10 million.in one second computer can do O(10^9) operations. since most of the times time limit is 1 second or 2 second you can do as below most of the cases. If an array is given the size of 10^5 . so you can apply o(N)(10^5) or O(NlogN) (10^5*log(10^5)) kinda algorithm in that cases. If array size is like 5000 somthing you can apply O(N^2) or maybe sometimes O(N^3) algorithm. if size~100 you can apply O(N^4) algorithm. So main thing is in one second you can do 10^9 operations keeping in mind , on seeing constraints calculate upper bound and think accordingly. And one thing is no of test cases. It should be also consider in taking time complexity. Hope this helps.

got it. thanks :)

In G, if you use floyd with int values it will pass. But using long long is causing TLE.

There's a typo in the editorial of F. The current remainder is denoted by cnt instead of rem

[DELETED]

Asked for help only to get downvoted. What's wrong in asking for help politely :(

Use "spoler" or just link the submission. It's not nice to scroll through codes in comment section

Thanks for the tip! Updated.

Keep applying mod operation with function calls.

I think this will be one of the easiest solutions of problem F to learn, I haven't use comments, but the code is clean though.

Has anyone seen more problems like F? Editorial says it's a standard DP.

Also, What are some other standard DP problems not commonly available?

It's basically 0/1 knapsack DP in a 2d grid. For some other standard DP problem you can check CSES problemset DP section.

Actually, it's the variation in standard problems that's tough.

It would be nice if you can share some problems which are a variation of these standard problems.

https://mirror.codeforces.com/contest/1433/submission/96212192 Can you tell me where i am doing wrong in my code for problem F??

I think you must take sum in your dp with MOD; int val= solution(i,j+1,count-1,(sum+arr[i][j] % k)); (sum + arr[i][j]) % k try this

where to put this line?? my dp state storing sum of numbers why to store with mod??

https://mirror.codeforces.com/contest/1433/submission/96227486

I copy your code and set parentheses in this line

In the

problem F,What happens when we initialize dp array with $$$0$$$ instead of

`INT_MIN`

or`LLONG_MIN`

? I tried this and got wrong answer. But overall, the value of every state is going to become zero before we arrive that state during dp transition. So how does initialising values with zero go wrong?Never mind.

int_min denotes that this state is impossible. If you initialise it as 0, you can distinguish between impossible states and states with sum 0.

But, if the state is impossible, it will have 0 sum, as we won't be able to create an impossible state. Also, the minimum sum that can be created is 0, not $$$-inf$$$.

You can check the Accepted submission, and the one with Wrong Answer. You can see, the code with zero initialised dp array creates a difference of 1 in the first testcase.

Try inputting some larger cases, deviation will be much greater than one.

In problem E, why are we dividing by 2 in last step? Can Anyone explain in detail?

Suppose we select n/2 members in first dance group and then the rest n/2 will automatically form the next dance group. But the formula here considers that the first n/2 and rest n/2 are 2 different cases. Hence we need to divide the value by 2 to make them identical.

Every selection is accompanied by a rejection.

For eg — S = {1, 2, 3, 4}

There (6C2) ways to choose 2 elements. But suppose you select {1, 2} then {3, 4} is automatically selected. Now you don't want to select {3, 4} again and {1, 2}, because this will be counted twice. So to avoid counting again, we divide by 2.

When we are taking C(n,n/2) we are counting how many ways we can take n/2 different elements from n elements.

Let's say n = 1, 2, 3, 4, 5, 6, 7, 8

we can take one round as (1, 2, 3, 4) and the other round will be (5, 6, 7, 8)

we can take one round as (5, 6, 7, 8) and the other round will be (1 ,2, 3, 4)

But both are the same configuration. So we are counting it twice, hence we need to divide the C(n, n/2) by two.

How much more time would be taken in reflecting the rating changes from this round 677? Or has the contest become unrated!?

Hello Everyone.... Can someone please explain why we multiplied with (n/2-1)! in E (two round dances) problem.

UPD: SolvedThere are two round dances each time and each one can have (n/2-1)! permutations everytime.

For n people in a circle, there are (n-1)! permutations in which they can be arranged

why does rating change for Div3 and educational rounds take sooooo long???

because there is hacking phase of around 12 hours in these rounds.So after that system testing happens and ratings get updated.:)

It has been 5 hrs since the hacking phase ended.

Can F be solved with a greedy solution???

I don't think it can. I tried sorting every row, taking last m/2 elements and if the sum is not divisible by k than removing the element which difference from the previous in its row is the smallest, but this doesn't work. It also doesn't work if you simply try to remove the smallest element you find. So I don't think you can solve it with some kind of greedy.

We could do it this way, sort all the elements then for each max val "a", get a max val "b" from any row such the (a+b)%k == 0 and number of numbers taken from rows of "a" and "b" is not more than m/2.

It won't work, since it's possible for some "a", there does not exist "b" such that (a+b)%k==0 i.e, Cases where (a+b+c)%k==0, or sum of more number of elements will be div by k.

Ya that would surely fail my solution. Thanks for the replies

I don't see how that would work. What if the number of elements you can take is not even. What if for example you can take only 4 numbers (2 from 2 rows) and you can't find pairs such that (a + b) % k == 0 but sum of all 4 is divisible by k 2 4 10 1 1 5 9 1 1 2 4 Here the answer would be 20 but your algorithm would not even find that. Also you would have to pay attention to how many numbers have you taken from which row. So I don't think that works

Ya that would surely fail my solution. Thanks for the replies

@vovuh start system testing so we can get our rating :P..

This contest is pretty easy. A speedrun is required like this contest.

for problem G, what is the disadvantage in this apporach: -> find shortest paths (not just lengths) for all delivery routes -> find the intersection paths among all and keep track of the largest weight -> set it to 0 then from the total cost , subtract , largest_weight*number_of_delivery_routes

Your idea will fail in the 2nd sample. The largest weight will be 5 on the intersection paths but that's clearly not the edge we want to reduce to 0.

There is another way of thinking the partitioning of the given set in Problem E. Instead of dividing $$$\binom{n}{n / 2}$$$ by $$$2$$$, we can fix some arbitrary element, let's say $$$1$$$, and count in how many ways we can choose the other elements in $$$1$$$'s subset. That is $$$\binom{n - 1}{n / 2 - 1}$$$. This way, we don't have to worry about counting some configurations twice or more. And this idea can be applied in more complex recurrences involving set partitioning, like Bell Numbers, where the

divide by $$$2$$$thing won't work anymore.vovuh there is a

typoinF'sEditorial, the first paragraph:...., we took cnt elements in the row x and our current remainder is`cnt`

.(this`cnt`

should be`rem`

)!Thank you!

int idx = -1; for (int i = 0; i < n; ++i) { if (a[i] != mx) continue; if (i > 0 && a[i — 1] != mx) idx = i + 1; if (i < n — 1 && a[i + 1] != mx) idx = i + 1; }

In C ,I can't understand this iteration , can anybody please kindly explain this part ? or why does it work?

This loop only looks at the largest elements because they can surely become dominant. For a pirana to be dominant it needs to have at least one pirana(left or right) that has smaller value. First if cheks for piranas on left. Second if cheks for piranas on right.

Wyh Dijstra work well in problem G?Is't it O(n^2 log m)?I think SPFA is faster.

Dijkstra on sparse graphs: O(ElogV).

Running V times is O(VElogV)

When will ratings update?

Same Question

It's done already

`dp[x][y+1][cnt+1][(rem+ax,y)%k]=max(dp[x][y+1][cnt+1][(rem+ax,y)%k],dp[x][y][cnt][rem]+axy)`

I am not able to understand this transition. What does

`dp[x][y][cnt][rem]+axy`

exactly mean?UPD :Understood. We are looking whether or not it is beneficial to take the current element or not.vovuh What would be the Worst Case Time Complexity for the problem F using this DP approach.

Hi, for problem F, I submitted 2 codes.

One has

dp arrayinitialized to -1, other has it initialized to -2.-1 works and gives.Acceptedbut -2 doesntWhy so?-1 => 96209145

-2=> 96263305

`memset(dp, -2, sizeof(dp));`

does not do what you think it does.`memset`

sets the value of every byte, not the actual element on the array.`0`

and`-1`

works as intended because their binary representations have all zeroes and ones respectively.Ohhhhh..... thanks a lot. I understood now. so memset(dp, 5, sizeof(dp)) is also wrong?

It's not "wrong", it will do what it's supposed to do- set all bytes to 1, 0, 1 continuously.

It won't replace every elements with 5.

oh so for array of

bitsof size 5 called dp, memset(dp,5,sizeof(dp)) will do-> 1,0,1,1,0 ??Bytes, not bits. So, every 8 bits of the array will be converted to`10100000`

.I'm not sure if that's reliable enough though.

`memset(dp, -2, sizeof(dp));`

-2 is illegal， only 0, -1 or some Hexadecimal number like 0x3f3f3f3fMyCode Can anyone help me? My code almost same as the standard solution, but get wrong answer on test 3

the tutorial for problem C is wrong for the example test case:

n=5; arr=[5,3,4,4,5];

resultant output=5 expected output=3

any helps regarding this?

Both are correct!

If the output is 5, 5 eats 4, 3, 2, 1.

`[5,3,4,4,5]`

->`[5,3,4,6]`

->`[5,3,7]`

->`[5,8]`

->`[9]`

If the output is 3, 3 eats 2, 4, 5, 1.

`[5,3,4,4,5]`

->`[5,5,4,5]`

->`[5,6,5]`

->`[5,7]`

->`[8]`

96297177 code for F with comments

Nice!

The problems were fine, but I don't think E is an appropriate problem, 2 reasons.

1)99% Math (Which is still fine, as most algorithm problems can be restated as Math problem, though this was a bit direct)

2) OEIS (I hate using OEIS, and I hate problems that allows to use OEIS, because there is literally no fun in it, and we don't learn anything new and you are caught when asked to do the same problem in onsite, but Div3 is a sprint race, when most of them use oeis and you don't, your rating suffers)

P.S. You don't even have to think of a few cases, you can copy paste 12164510040883200 in the OEIS search

I have no problem with a little of combinatorics, but OEIS feels like cheating. And our friend 1000000007 would have easily done away with that.

If we are (i,j) then why are we taking the state dp[i][j+1]? Shouldn't we take dp[i][j]?

This is the second time I joined in the Codeforces contests. Such a nice one!

I don't understand why the answer is dp[n][0][0][0] in problem F

In problem F: The transitions from the last element of the row are almost the same, but the next element is a[x+1][0] and the new value of cnt is always zero.

Why cnt is equal to 0, even if we take the current element?

my solution for problem G is somewhat same as that given in the tutorial, however, I am getting TLE. any suggestion? link to solution — https://mirror.codeforces.com/contest/1433/submission/104609982